import os


indice = -1
name_prev = None

outdir = "data_measurements"
if not os.path.exists(outdir):
    os.makedirs(outdir)

with open("CHERNAIR.TXT") as datafile:
    lines = datafile.readlines()

filetmp = None
with open("data_measurements/stations_file.dat", 'w') as statfile:
    for line in lines:
        if (len(line)) < 10:
            continue
        # Discard uncertain measurements.
        if len(line[86:123].split()) > 3:
            continue

        country = line[2:4].strip()
        # Removes useless parts of some station names.
        name_tmp = line[5:38].strip()
        if len(name_tmp.split(" ")) > 1:
            if name_tmp.split(" ")[1][0] == "(":
                name = name_tmp.split(" ")[0].strip()
            elif len(name_tmp.split(",")) > 1:
                name = name_tmp.split(",")[0].strip()
            else:
                name = name_tmp.replace(" ", "_").strip()
        else:
            name = name_tmp.strip()
        lat = line[38:46].strip()
        lon = line[49:57].strip()
        # There is a problem in "CHERNAIR.txt" with some coordinates.
        if name == "VAERNES":
            lon = "10.940000"
            lat = "63.460000"
        if name == "VALENCIA":
            lon = "-0.383000"
            lat = "39.483000"
        if name == "HARWELL_2" or name == "HARWELL_3":
            name = "HARWELL"
        if name != name_prev:
            print name
            indice = indice + 1
            statfile.write(str(indice).ljust(4) + "\t " \
                       + str(lon).ljust(8) + " \t " \
                       + str(lat).ljust(8) + " \t " \
                       + str(name).ljust(20) + " \t " \
                       + str(country).ljust(4) + "\n")
            nametmp = str(name) + ".dat"
            if filetmp:
                filetmp.close()
            filetmp = open(outdir + "/" + nametmp, 'w')
            name_prev = name

        date = line[58:66].strip()
        hour = line[67:72].strip()
        length = line[75:81].strip()

        I131 = line[86:95].strip()
        Cs134 = line[100:108].strip()
        Cs137 = line[114:123].strip()
        filetmp.write(date + "\t" + hour + "\t" + length + "\t" + I131 \
                  + "\t" + Cs134 + "\t" + Cs137 + "\n")

filetmp.close()
